using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;
 
namespace OlAttachExample
{
	[ComVisible(false)]
    public class OlItemEvents : OutlookItemEvents_BaseLogic
    {
		private long maxsize = 100000;

        public OlItemEvents(AddinModule module): base(module)
        {
        }
 
        public override void ProcessAttachmentAdd(object attachment)
        {
			Outlook.Attachment attch = attachment as Outlook.Attachment;
			if (attch.Parent is Outlook._MailItem)
			{
				Outlook._MailItem item = null;
				try
				{
					IntPtr unk = IntPtr.Zero;
					object mapiObject = null; 
					IntPtr unkObj = IntPtr.Zero;
					
					item = attch.Parent as Outlook._MailItem;
					try
					{
						item.Save();
						mapiObject = attch.MAPIOBJECT;
						unkObj = Marshal.GetIUnknownForObject(mapiObject);
						Guid iMapiProp = new Guid("00020303-0000-0000-C000-000000000046");
						Marshal.QueryInterface(unkObj, ref iMapiProp, out unk);
						if (unk != IntPtr.Zero)
						{
							IntPtr pPropValue = IntPtr.Zero;
							try
							{
								MAPI.HrGetOneProp(unk, MAPI.PR_ATTACH_SIZE, out pPropValue);
								MAPI.SPropValue propValue = (MAPI.SPropValue)Marshal.PtrToStructure(pPropValue, typeof(MAPI.SPropValue));
								long size = propValue.Value;
								if (size > maxsize)
								{
									MessageBox.Show("This attachment is greater than " + maxsize.ToString() + " bytes. It will not be added.");
									Outlook.Attachments collection = null;
									try
									{
										collection = item.Attachments;
										collection.Remove(attch.Index);
										item.Save();
									}
									finally
									{
										if (collection != null)
											Marshal.ReleaseComObject(collection);
									}
								}
							}
							catch
							{
							}
							if (pPropValue != IntPtr.Zero) 
								MAPI.MAPIFreeBuffer(pPropValue);
						}

					}
					finally
					{
						if (unkObj != IntPtr.Zero) 
							Marshal.Release(unkObj);
						if (unk != IntPtr.Zero)
							Marshal.Release(unk);
						if (mapiObject != null)
							Marshal.ReleaseComObject(mapiObject);
					}
				}
				finally
				{
					if (item != null)
						Marshal.ReleaseComObject(item);
				}
			}
		}
 
        public override void ProcessAttachmentRead(object attachment)
        {
			// TODO: Add some code
        }
 
        public override void ProcessBeforeAttachmentSave(object attachment, CancelEventArgs e)
        {
			// TODO: Add some code
        }
 
        public override void ProcessBeforeCheckNames(CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessClose(CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessCustomAction(object action, object response, CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessCustomPropertyChange(string name)
        {
            // TODO: Add some code
        }
 
        public override void ProcessForward(object forward, CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessOpen(CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessPropertyChange(string name)
        {
            // TODO: Add some code
        }
 
        public override void ProcessRead()
        {
            // TODO: Add some code
        }
 
        public override void ProcessReply(object response, CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessReplyAll(object response, CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessSend(CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessWrite(CancelEventArgs e)
        {
            // TODO: Add some code
        }
 
        public override void ProcessBeforeDelete(object item, CancelEventArgs e)
        {
            // TODO: Add some code
        }

		private class MAPI
		{
			public const uint PR_TRANSPORT_MESSAGE_HEADERS = 0x7D001E;
			public const uint PR_BODY = 0x1000001E;
			public const uint PR_BODY_HTML = 0x1013001E;
			public const uint PR_HTML = 0x10130102;
			public const uint PT_LONG = 3;
			public const uint PR_ATTACH_SIZE = ((((uint)(0x0E20))<<16)|((uint)(PT_LONG)));

			public struct SPropValue
			{
				public uint ulPropTag;
				public uint dwAlignPad;
				public long Value;
			}
        
			[DllImport("MAPI32.DLL", CharSet=CharSet.Ansi, EntryPoint="HrGetOneProp@12")]
			public static extern void HrGetOneProp(IntPtr pmp, uint ulPropTag, out IntPtr ppProp);

			[DllImport("MAPI32.DLL", CharSet=CharSet.Ansi, EntryPoint="MAPIFreeBuffer@4")]
			public static extern void MAPIFreeBuffer(IntPtr lpBuffer);
		}
	}

	[ComImport(), ComVisible(false), 
	Guid("0006303A-0000-0000-C000-000000000046"),
	InterfaceType(ComInterfaceType.InterfaceIsIDispatch)]
	public interface IOlItemEvents
	{
		[DispId(0x0000f003)] void Open(ref bool cancel);
		[DispId(0x0000f006)] void CustomAction(object action, object response, ref bool cancel);
		[DispId(0x0000f008)] void CustomPropertyChange([MarshalAs(UnmanagedType.LPWStr)] string name);
		[DispId(0x0000f468)] void Forward(object forward, ref bool cancel);
		[DispId(0x0000f004)] void Close(ref bool cancel);
		[DispId(0x0000f009)] void PropertyChange([MarshalAs(UnmanagedType.LPWStr)] string name);
		[DispId(0x0000f001)] void Read();
		[DispId(0x0000f466)] void Reply(object response, ref bool cancel);
		[DispId(0x0000f467)] void ReplyAll(object response, ref bool cancel);
		[DispId(0x0000f005)] void Send(ref bool cancel);
		[DispId(0x0000f002)] void Write(ref bool cancel);
		[DispId(0x0000f00a)] void BeforeCheckNames(ref bool cancel);
		[DispId(0x0000f00b)] void AttachmentAdd(object attachment);
		[DispId(0x0000f00c)] void AttachmentRead(object attachment);
		[DispId(0x0000f00d)] void BeforeAttachmentSave(object attachment, ref bool cancel);
	}

	[ComVisible(false)]
	public abstract class OutlookItemEvents_BaseLogic : System.IDisposable 
	{
		private bool disposed = false;
		private OlItemEvents_SinkHelper sinkHelper;
		private AddinExpress.MSO.ADXAddinModule module = null;

		public OutlookItemEvents_BaseLogic(AddinModule module)
		{
			if (module == null)
				throw new ApplicationException("The reference is not set to an instance of the ADXAddinModule class.");
			this.module = module;
			sinkHelper = new OlItemEvents_SinkHelper(module, this);
		}

		~OutlookItemEvents_BaseLogic() 
		{ 
			Dispose(); 
		} 

		public void Dispose() 
		{ 
			Free(); 
			GC.SuppressFinalize(this); 
		} 

		private void Free() 
		{ 
			if (!disposed) 
			{ 
				disposed = true; 
				sinkHelper.Dispose();
			} 
		} 

		public object ItemObj
		{
			get
			{
				return sinkHelper.ItemObj;
			}
		}

		public AddinExpress.MSO.ADXAddinModule Module
		{
			get
			{
				return module;
			}
		}

		public bool IsConnected
		{
			get
			{
				return sinkHelper.IsConnected;
			}
		}

		public bool ConnectTo(object olItem, bool own) 
		{
			return sinkHelper.ConnectTo(olItem, own);
		}

		public void RemoveConnection() 
		{
			sinkHelper.RemoveConnection();
		}

		public abstract void ProcessAttachmentAdd(object attachment);
		public abstract void ProcessAttachmentRead(object attachment);
		public abstract void ProcessBeforeAttachmentSave(object attachment, CancelEventArgs e);
		public abstract void ProcessBeforeCheckNames(CancelEventArgs e);
		public abstract void ProcessClose(CancelEventArgs e);
		public abstract void ProcessCustomAction(object action, object response, CancelEventArgs e);
		public abstract void ProcessCustomPropertyChange(string name);
		public abstract void ProcessForward(object forward, CancelEventArgs e);
		public abstract void ProcessOpen(CancelEventArgs e);
		public abstract void ProcessPropertyChange(string name);
		public abstract void ProcessRead();
		public abstract void ProcessReply(object response, CancelEventArgs e);
		public abstract void ProcessReplyAll(object response, CancelEventArgs e);
		public abstract void ProcessSend(CancelEventArgs e);
		public abstract void ProcessWrite(CancelEventArgs e);
		public abstract void ProcessBeforeDelete(object item, CancelEventArgs e);
	}

	[ComVisible(false)]
	public class CancelEventArgs: System.EventArgs
	{
		private bool cancel;

		internal CancelEventArgs()
		{
			cancel = false;
		}

		public bool Cancel
		{
			get
			{
				return cancel;
			}
			set
			{
				cancel = value;
			}
		}
	}

	[ClassInterface(ClassInterfaceType.None)]
	public class OlItemEvents_SinkHelper : IOlItemEvents, System.IDisposable
	{
		private bool disposed = false;
		private UCOMIConnectionPointContainer oConnPointContainer;
		private UCOMIConnectionPoint m_oConnectionPoint;
		private int m_Cookie;
		private object olItemObj;
		protected AddinModule module;
		private bool connected = false;
		private bool owner4Folder = false;
		protected OutlookItemEvents_BaseLogic wrapper;

		internal OlItemEvents_SinkHelper(AddinModule module, OutlookItemEvents_BaseLogic wrapper)
		{
			oConnPointContainer = null; m_oConnectionPoint = null;
			m_Cookie = 0; this.module = module;
			olItemObj = null; this.wrapper = wrapper;
		}

		public void Dispose() 
		{ 
			Free(); 
			GC.SuppressFinalize(this); 
		} 

		private void Free() 
		{ 
			if (!disposed) 
			{ 
				RemoveConnection(); 
				module = null; 
				disposed = true; 
			} 
		} 

		internal object ItemObj
		{
			get
			{
				return olItemObj;
			}
		}

		internal bool IsConnected
		{
			get
			{
				return connected;
			}
		}

		internal bool ConnectTo(object olItem, bool own)
		{
			if (module.HostType != AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook) 
				return false;
			if (m_Cookie != 0) 
				RemoveConnection();
			try
			{
				olItemObj = olItem;
				if (olItem != null)
				{
					owner4Folder = own;
					Guid guid = new Guid("0006303A-0000-0000-C000-000000000046");
					oConnPointContainer = (UCOMIConnectionPointContainer)olItem;
					oConnPointContainer.FindConnectionPoint(ref guid, out m_oConnectionPoint);
					if (m_oConnectionPoint != null)
					{
						m_oConnectionPoint.Advise(this, out m_Cookie);
						connected = (m_Cookie > 0);
					}
					oConnPointContainer = null;
				}
			}
			catch
			{
			}
			return connected;
		} 

		internal void RemoveConnection() 
		{ 
			try
			{
				if (m_Cookie != 0 && m_oConnectionPoint != null)
				{
					try
					{
						m_oConnectionPoint.Unadvise(m_Cookie);
					}
					catch
					{
					}
					m_Cookie = 0; 
					Marshal.ReleaseComObject(m_oConnectionPoint);
					if (owner4Folder)
						Marshal.ReleaseComObject(olItemObj);
					olItemObj = null;
				}
			}
			finally
			{
				connected = false;
				owner4Folder = false;
			}
		} 

		void IOlItemEvents.AttachmentAdd(object attachment)
		{
			try
			{
				wrapper.ProcessAttachmentAdd(attachment);
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				Marshal.ReleaseComObject(attachment); 
			}
		}

		void IOlItemEvents.AttachmentRead(object attachment)
		{
			try
			{
				wrapper.ProcessAttachmentRead(attachment);
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				Marshal.ReleaseComObject(attachment); 
			}
		}

		void IOlItemEvents.BeforeAttachmentSave(object attachment, ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessBeforeAttachmentSave(attachment, e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				Marshal.ReleaseComObject(attachment); 
			}
		}

		void IOlItemEvents.BeforeCheckNames(ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessBeforeCheckNames(e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void IOlItemEvents.Close(ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessClose(e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void IOlItemEvents.CustomAction(object action, object response, ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessCustomAction(action, response, e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				Marshal.ReleaseComObject(action); 
				Marshal.ReleaseComObject(response); 
			}
		}

		void IOlItemEvents.CustomPropertyChange(string name)
		{
			try
			{
				wrapper.ProcessCustomPropertyChange(name);
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void IOlItemEvents.Forward(object forward, ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessForward(forward, e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				Marshal.ReleaseComObject(forward); 
			}
		}

		void IOlItemEvents.Open(ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessOpen(e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void IOlItemEvents.PropertyChange(string name)
		{
			try
			{
				wrapper.ProcessPropertyChange(name);
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void IOlItemEvents.Read()
		{
			try
			{
				wrapper.ProcessRead();
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void IOlItemEvents.Reply(object response, ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessReply(response, e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				Marshal.ReleaseComObject(response); 
			}
		}

		void IOlItemEvents.ReplyAll(object response, ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessReplyAll(response, e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				Marshal.ReleaseComObject(response); 
			}
		}

		void IOlItemEvents.Send(ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessSend(e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		void IOlItemEvents.Write(ref bool cancel)
		{
			try
			{
				CancelEventArgs e = new CancelEventArgs();
				wrapper.ProcessWrite(e);
				cancel = e.Cancel;
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, e.Source, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}
	}
}

